



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>升级MySQL5.7，开发不得不注意的坑</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">升级MySQL5.7，开发不得不注意的坑</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 07:49:04 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>前段时间，将线上MySQL数据库升级到了5.7。考虑到可能产生的不兼容性，在升级之前，确实也是战战兢兢，虽然测试环境，开发环境早在半年前就已提前升级。</p>
<p>基于前期的调研和朋友的反馈，与开发相关的主要有两点：</p>
<p><strong>sql_mode</strong></p>
<p>MySQL 5.6中，其默认值为"NO_ENGINE_SU BSTITUTION"，可理解为非严格模式，譬如，对自增主键插入空字符串''，虽然提示warning，但并不影响自增主键的生成。</p>
<p>但在MySQL 5.7中，其就调整为了严格模式，对于上面这个，其不会提示warning，而是直接报错。</p>
<p><strong>分组求最值</strong></p>
<p>分组求最值的某些写法在MySQL5.7中得不到预期结果，这点，相对来说比较隐蔽。</p>
<p>其中，第一点是可控的，毕竟可以调整参数。而第二点，却是不可控的，没有参数与之相关，需要开发Review代码。</p>
<h4><strong>下面具体来看看</strong></h4>
<p>测试数据</p>
<div>
<pre class="prettyprint linenums">mysql&gt; select * from emp;<br />
+-------+----------+--------+--------+<br />
| empno | ename    | sal    | deptno |<br />
+-------+----------+--------+--------+<br />
|  1001 | emp_1001 | 100.00 |     10 |<br />
|  1002 | emp_1002 | 200.00 |     10 |<br />
|  1003 | emp_1003 | 300.00 |     20 |<br />
|  1004 | emp_1004 | 400.00 |     20 |<br />
|  1005 | emp_1005 | 500.00 |     30 |<br />
|  1006 | emp_1006 | 600.00 |     30 |<br />
+-------+----------+--------+--------+<br />
6 rows in set (0.00 sec)</pre>
</div>
<p>其中，empno是员工编号，ename是员工姓名，sal是工资，deptno是员工所在部门号。</p>
<p><strong>业务的需求是，求出每个部门中工资最高的员工的相关信息。</strong></p>
<p>在MySQL5.6中，我们可以通过下面这个SQL来实现，</p>
<div>
<pre class="prettyprint linenums">SELECT<br />
    deptno,ename,sal<br />
FROM<br />
    ( SELECT * FROM emp ORDER BY sal DESC ) t<br />
GROUP BY<br />
    deptno;</pre>
</div>
<p>结果如下，可以看到，其确实实现了预期效果。</p>
<div>
<div>
<div>
<pre class="prettyprint linenums">+--------+----------+--------+<br />
| deptno | ename    | sal    |<br />
+--------+----------+--------+<br />
|     10 | emp_1002 | 200.00 |<br />
|     20 | emp_1004 | 400.00 |<br />
|     30 | emp_1006 | 600.00 |<br />
+--------+----------+--------+</pre>
</div>
<p>再来看看MySQL5.7的结果，竟然不一样。</p>
<div>
<pre class="prettyprint linenums">+--------+----------+--------+<br />
| deptno | ename    | sal    |<br />
+--------+----------+--------+<br />
|     10 | emp_1001 | 100.00 |<br />
|     20 | emp_1003 | 300.00 |<br />
|     30 | emp_1005 | 500.00 |<br />
+--------+----------+--------+</pre>
</div>
<p>实际上，在MySQL5.7中，对该SQL进行了改写，改写后的SQL可通过explain(extended) + show warnings查看。</p>
<div>
<pre class="prettyprint linenums">mysql&gt; explain select deptno,ename,sal from (select * from emp order by sal desc) t group by deptno;<br />
+----+-------------+-------+------------+------+---------------+------+---------+------+------+----------+-----------------+<br />
| id | select_type | table | partitions | type | possible_keys | key  | key_len | ref  | rows | filtered | Extra           |<br />
+----+-------------+-------+------------+------+---------------+------+---------+------+------+----------+-----------------+<br />
|  1 | SIMPLE      | emp   | NULL       | ALL  | NULL          | NULL | NULL    | NULL |    6 |   100.00 | Using temporary |<br />
+----+-------------+-------+------------+------+---------------+------+---------+------+------+----------+-----------------+<br />
1 row in set, 1 warning (0.00 sec)

mysql&gt; show warnings\G<br />
*************************** 1. row ***************************<br />
  Level: Note<br />
   Code: 1003<br />
Message: /* select#1 */ select `slowtech`.`emp`.`deptno` AS `deptno`,`slowtech`.`emp`.`ename` AS `ename`,`slowtech`.`emp`.`sal` AS `sal` from `slowtech`.`emp` group by `slowtech`.`emp`.`deptno`<br />
1 row in set (0.00 sec)</pre>
</div>
<p>从改写后的SQL来看，其消除了子查询，导致结果未能实现预期效果，官方也证实了这一点，<a href="https://bugs.mysql.com/bug.php?id=80131" rel="external nofollow noreferrer">https://bugs.mysql.com/bug.php?id=80131</a></p>
<p>很多人可能不以为然，认为没人会这样写，但在大名鼎鼎的stackoverflow中，该实现的点赞数就有116个-由此可见其受众之广，仅次于后面提到的&ldquo;方法二&rdquo;（点赞数206个）。&nbsp;<br /><a href="https://stackoverflow.com/questions/12102200/get-records-with-max-value-for-each-group-of-grouped-sql-results" rel="external nofollow noreferrer">https://stackoverflow.com/questions/12102200/get-records-with-max-value-for-each-group-of-grouped-sql-results</a></p>
<p>需要注意的是，该SQL在5.7中是不能直接运行的，其会提示如下错误：</p>
<div>
<pre class="prettyprint linenums">ERROR 1055 (42000): Expression #2 of SELECT list is not in GROUP BY clause and contains nonaggregated column 't.ename' which is not functionally dependent on columns in GROUP BY clause; this is incompatible with sql_mode=only_full_group_by</pre>
</div>
<p>这个与sql_mode有关，在MySQL 5.7中，sql_mode调整为了</p>
<div>
<pre class="prettyprint linenums">ONLY_FULL_GROUP_BY,STRICT_TRANS_TABLES,NO_ZERO_IN_DATE,NO_ZERO_DATE,ERROR_FOR_DIVISION_BY_ZERO,NO_AUTO_CREATE_USER,NO_ENGINE_SUBSTITUTION</pre>
</div>
<p>其中，ONLY_FULL_GROUP_BY与group by语句有关，其要求select列表里只能出现分组列（即group by后面的列）和聚合函数（sum，avg，max等），这也是SQL92的标准。</p>
<p>但在工作中，却经常看到开发写出下面这种SQL。</p>
<div>
<pre class="prettyprint linenums">mysql&gt; select deptno,ename,max(sal) from emp group by deptno;<br />
+--------+----------+----------+<br />
| deptno | ename    | max(sal) |<br />
+--------+----------+----------+<br />
|     10 | emp_1001 |   200.00 |<br />
|     20 | emp_1003 |   400.00 |<br />
|     30 | emp_1005 |   600.00 |<br />
+--------+----------+----------+<br />
3 rows in set (0.01 sec)</pre>
</div>
<p>实在不明白，这里的ename在业务层有何意义，毕竟，他并不是工资最高的那位员工。</p>
<h4><strong>分组求最值，MySQL的实现方式</strong></h4>
<p>其实分组求最值是一个很普遍的需求。在工作中，也经常被开发同事问到。 下面具体来看看，MySQL中有哪些实现方式。</p>
<p><strong>方法1</strong></p>
<div>
<pre class="prettyprint linenums">SELECT<br />
    e.deptno,<br />
    ename,<br />
    sal<br />
FROM<br />
    emp e,<br />
    ( SELECT deptno, max( sal ) maxsal FROM emp GROUP BY deptno ) t<br />
WHERE<br />
    e.deptno = t.deptno<br />
    AND e.sal = t.maxsal;</pre>
</div>
<p><strong>方法2</strong></p>
<div>
<pre class="prettyprint linenums">SELECT<br />
    a.deptno,<br />
    a.ename,<br />
    a.sal<br />
FROM<br />
    emp a<br />
    LEFT JOIN emp b ON a.deptno = b.deptno<br />
    AND a.sal &lt; b.sal<br />
WHERE<br />
    b.sal IS NULL;</pre>
</div>
<p>这两种实现方式，其实是通用的，不仅适用于MySQL，也适用于其它主流关系型数据库。</p>
<p><strong>方法3</strong><br />MySQL 8.0推出了分析函数，其也可实现类似功能。</p>
<div>
<pre class="prettyprint linenums">SELECT<br />
    deptno,<br />
    ename,<br />
    sal<br />
FROM<br />
    (<br />
    SELECT<br />
        deptno,<br />
        ename,<br />
        sal,<br />
        LAST_VALUE ( sal ) OVER ( PARTITION BY deptno ORDER BY sal ROWS BETWEEN UNBOUNDED PRECEDING AND UNBOUNDED FOLLOWING ) maxsal<br />
    FROM<br />
        emp<br />
    ) a<br />
WHERE<br />
    sal = maxsal;</pre>
</div>
<h4><strong>三种实现方式的性能对比</strong></h4>
<p>因上面测试案例的数据量太小，三种实现方式的结果都是秒出，仅凭执行计划很难直观地看出实现方式的优劣。</p>
<p>下面换上数据量更大的测试数据，官方示例数据库employees中的dept_emp表，<a href="https://github.com/datacharmer/test_db" rel="external nofollow noreferrer">https://github.com/datacharmer/test_db</a></p>
<p>表的相关信息如下，其中emp_no是员工编号，dept_no是部门编号，from_date是入职日期。</p>
<div>
<pre class="prettyprint linenums">mysql&gt; show create table dept_emp\G<br />
*************************** 1. row ***************************<br />
       Table: dept_emp<br />
Create Table: CREATE TABLE `dept_emp` (<br />
  `emp_no` int(11) NOT NULL,<br />
  `dept_no` char(4) NOT NULL,<br />
  `from_date` date NOT NULL,<br />
  `to_date` date NOT NULL,<br />
  KEY `dept_no` (`dept_no`,`from_date`)<br />
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci<br />
1 row in set (0.00 sec)

mysql&gt; select count(*) from dept_emp;<br />
+----------+<br />
| count(*) |<br />
+----------+<br />
|   331603 |<br />
+----------+<br />
1 row in set (0.09 sec)

mysql&gt; select * from dept_emp limit 1;<br />
+--------+---------+------------+------------+<br />
| emp_no | dept_no | from_date  | to_date    |<br />
+--------+---------+------------+------------+<br />
|  10001 | d005    | 1986-06-26 | 9999-01-01 |<br />
+--------+---------+------------+------------+<br />
1 row in set (0.00 sec)</pre>
</div>
<p><strong>方法1</strong></p>
<div>
<pre class="prettyprint linenums">mysql&gt; select d.dept_no,d.emp_no,d.from_date from dept_emp d, (select dept_no,max(from_date) max_hiredate from dept_emp group by dept_no) t where d.dept_no=t.dept_no and d.from_date=t.max_hiredate;<br />
&hellip;<br />
12 rows in set (0.00 sec)

mysql&gt; explain select d.dept_no,d.emp_no,d.from_date from dept_emp d, (select dept_no,max(from_date) max_hiredate from dept_emp group by dept_no) t where d.dept_no=t.dept_no and d.from_date=t.max_hiredate;<br />
+----+-------------+------------+------------+-------+---------------+---------+---------+--------------------------+------+----------+----------------------<br />
| id | select_type | table      | partitions | type  | possible_keys | key     | key_len | ref                      | rows | filtered | Extra<br />
+----+-------------+------------+------------+-------+---------------+---------+---------+--------------------------+------+----------+----------------------<br />
|  1 | PRIMARY     | &lt;derived2&gt; | NULL       | ALL   | NULL          | NULL    | NULL    | NULL                     |    9 |   100.00 | Using where<br />
|  1 | PRIMARY     | d          | NULL       | ref   | dept_no       | dept_no | 19      | t.dept_no,t.max_hiredate |    5 |   100.00 | NULL<br />
|  2 | DERIVED     | dept_emp   | NULL       | range | dept_no       | dept_no | 16      | NULL                     |    9 |   100.00 | Using index for group-by<br />
+----+-------------+------------+------------+-------+---------------+---------+---------+--------------------------+------+----------+----------------------</pre>
</div>
<p><strong>方法2</strong></p>
<div>
<pre class="prettyprint linenums">mysql&gt; explain select a.dept_no,a.emp_no,a.from_date from dept_emp a left join dept_emp b on a.dept_no=b.dept_no and a.from_date &lt; b.from_date where b.from_date is null;<br />
+----+-------------+-------+------------+------+---------------+---------+---------+--------------------+--------+----------+--------------------------+<br />
| id | select_type | table | partitions | type | possible_keys | key     | key_len | ref                | rows   | filtered | Extra                    |<br />
+----+-------------+-------+------------+------+---------------+---------+---------+--------------------+--------+----------+--------------------------+<br />
|  1 | SIMPLE      | a     | NULL       | ALL  | NULL          | NULL    | NULL    | NULL               | 331008 |   100.00 | NULL                     |<br />
|  1 | SIMPLE      | b     | NULL       | ref  | dept_no       | dept_no | 16      | slowtech.a.dept_no |  41376 |    19.00 | Using where; Using index |<br />
+----+-------------+-------+------------+------+---------------+---------+---------+--------------------+--------+----------+--------------------------+<br />
2 rows in set, 1 warning (0.00 sec)</pre>
</div>
<p><strong>方法3</strong></p>
<div>
<pre class="prettyprint linenums">mysql&gt; select dept_no,emp_no,from_date from ( select dept_no,emp_no,from_date,last_value(from_date) over(partition by dept_no order by from_date rows between unbounded preceding and unbounded following) max_hiredate from dept_emp) a where from_date=max_hiredate;<br />
&hellip;<br />
12 rows in set (1.57 sec)

mysql&gt; desc select dept_no,emp_no,from_date from ( select dept_no,emp_no,from_date,last_value(from_date) over(partition by dept_no order by from_date rows between unbounded preceding and unbounded following) max_hiredate from dept_emp) a where from_date=max_hiredate;<br />
+----+-------------+------------+------------+------+---------------+------+---------+------+--------+----------+----------------+<br />
| id | select_type | table      | partitions | type | possible_keys | key  | key_len | ref  | rows   | filtered | Extra          |<br />
+----+-------------+------------+------------+------+---------------+------+---------+------+--------+----------+----------------+<br />
|  1 | PRIMARY     | &lt;derived2&gt; | NULL       | ALL  | NULL          | NULL | NULL    | NULL | 331008 |   100.00 | Using where    |<br />
|  2 | DERIVED     | dept_emp   | NULL       | ALL  | NULL          | NULL | NULL    | NULL | 331008 |   100.00 | Using filesort |<br />
+----+-------------+------------+------------+------+---------------+------+---------+------+--------+----------+----------------+<br />
2 rows in set, 2 warnings (0.00 sec)</pre>
</div>
<p><strong>从执行时间上看，</strong></p>
<p>方法1的时间最短，在有复合索引(deptno, fromdate)的情况下，结果瞬间就出来了，即使在没有索引的情况下，也只消耗了0.75s。</p>
<p>方法2的时间最长，3个小时还是没出结果。同样的数据，同样的SQL，放到Oracle查，也消耗了87分49秒。</p>
<p>方法3的时间比较固定，无论是否存在索引，都维持在1.5s左右，比方法1的耗时要久。</p>
<p>这里，对之前提到的，MySQL 5.7中不再兼容的实现方式也做了个测试，在没有任何索引的情况下，其稳定在0.7s（性能并不弱，怪不得有人使用），而同等情况下，方法1稳定在0.5s（哈，MySQL 5.6竟然比8.0还快）。但与方法1不同的是，其无法通过索引进行优化。</p>
<p><strong>从执行计划上看，</strong></p>
<p>方法1， 先将group by的结果放到临时表中，然后再将该临时表作为驱动表，来和dept_emp表进行关联查询。驱动表小（只有9条记录），关联列又有索引，无怪乎，结果能秒出。</p>
<p>方法2， 两表关联。其犯了SQL优化中的两个大忌。</p>
<p>1. 驱动表太大，其有331603条记录。</p>
<p>2. 被驱动表虽然也有索引，但从执行计划上看，其只使用了复合索引&nbsp; (dept_no, from_date)中的dept_no，而dept_no的选择率又太低，毕竟只有9个部门。</p>
<p>方法3， 先把分析的结果放到一个临时表中，然后再对该临时表进行处理。其进行了两次全表扫描，一次是针对dept_emp表，一次是针对临时表。</p>
<p><strong>所以，对于分组求最值的需求，建议使用方法1，其不仅符合SQL规范，查询性能上也是最好的，尤其是在联合索引的情况下。</strong></p>
<p><strong>PS：</strong></p>
<p><strong>经大神指点，对之前提到的，MySQL 5.7中不再兼容的实现方式，实际可以通过调整optimizer_switch来加以规避</strong></p>
<div>
<pre class="prettyprint linenums">set optimizer_switch='derived_merge=off';</pre>
</div>
<p>derived_merge是MySQL 5.7引入的，其会试图将Derived Table（派生表，from后面的子查询），视图引用，公用表表达式（Common table expressions）与外层查询进行合并。如，</p>
<div>
<pre class="prettyprint linenums">SELECT *<br />
  FROM t1 JOIN (SELECT t2.f1 FROM t2) AS derived_t2<br />
          ON t1.f2=derived_t2.f1<br />
  WHERE t1.f1 &gt; 0;</pre>
</div>
<p>改写为</p>
<div>
<pre class="prettyprint linenums">SELECT *<br />
 FROM t1 JOIN (SELECT DISTINCT f1 FROM t2) AS derived_t2<br />
         ON t1.f1=derived_t2.f1;</pre>
</div>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qy4ozjq.html">浅析MySQL中exists与in的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jpkel9.html">Power of Four（Difficulty&colon; Easy）</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j5gj08.html">tableview直接滚动至最后一行的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok1vj59.html">【转】JDBC为什么要使用PreparedStatement而不是Statement</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m713n8.html">hdu 4784 Dinner Coming Soon</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rglzlr8.html">【BZOJ1059】【ZJOI2007】矩阵游戏</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jze038.html">快速构建H5单页面切换应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojz4zeq.html">并发编程（十二）&mdash;&mdash; Java 线程池 实现原理与源码深度解析 之 submit 方法 （二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdnxpv9.html">SQL Server 快速大数据排序方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv21l5z9.html">HDU 1520&period;Anniversary party 基础的树形dp</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvljdl8.html">HTML float 和 absolute</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gwgrvq.html">react组件通信那些事儿</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy6ked9.html">Oracle 监听器日志配置与管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g7v0zq.html">java生成pdf文件  --- Table</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll7pg6q.html">IT行业的创新的读后感</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j16we49.html">java框架篇---Struts2 本地化&sol;国际化（i18n）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1rg05q.html">yum install 下载后保存rpm包</a>
		</li>
						<li><a href="https://www.batexi.com/a/9633l749.html">Spring Cloud Config 配置刷新</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkkmg38.html">SpringBoot整合cxf发布webService</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp3vm09.html">jquery选择器中的逗号</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8m2jlkoq.html">html&colon;常见行内标签，常见块级标签&comma;常见自闭合标签</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwjdmx9.html">产品经理说&vert; AIOps 让告警变得更智能 （下）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4mo6z9.html">The process could not read file xxx due to OS error 53</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wpvjwq.html">JMS Session session &equals; connection&period;createSession&lpar;paramA&comma;paramB&rpar; 两个参数不同组合下的含义和区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/qll1kx1q.html">mssql sqlserver 模拟for循环的写法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvlw3y8.html">Linux内核线程kernel thread详解--Linux进程的管理与调度（十）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zyk6k19.html">如何阅读luajit的代码&mdash;&mdash;用vs调试篇</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjokz59.html">oracle USING 用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwp2jk8.html">Windows 快捷方式（&ast;&period;link）打开方式关联错误</a>
			</li>
						<li><a href="https://www.batexi.com/a/90r214j9.html">C语言 实现逆置功能</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
